var infoButton = null;
var buttonObj = null;
var mouseDownInButton = false;
var prefsChanged = false;

/* diner HTML elements by ID, set in initDineomatic() */
var dinerName = null;
var dinerType = null;
var dinerList = null;
var dinerBar = null;
var dinnerPlate = null;
var icon = null;
var sndButton = null;

/* index randomly choosen eatery */
var pickedDiner = -1;
var randNum = -1;

/* state variables for diner icon animation */
var animateIndex = 0;
var animateTimer = null;
var vending = false;
var neonPlayCount = 0;

/* shuffleMax iterations + 1 final */
var shuffleCount = 0;
var shuffleMax = 20;
var shuffleFullSpdClicks = shuffleMax / 2; // 10 clicks with no delay

var shuffleExp = 2.925;
var shuffleExpDelay = 25;
var shuffleFinalDelay = -1;

var defaultDinerBarText = "Click plate to eat out!";
var emptyDinerBarText = "Please add eateries";

var dinerData = new Array();
var selectedRow = null;

/* sound enabled or not */
var soundEnabled = true;

/* if widget is hidden */
var widgetHidden = false;

/*
 * Array is pretty simple
 * 0: Diner Type Text
 * 1: Array of pngs, if more than 1 we animate
 * 2: Animation delay in milliseconds
 */
var dinerTypes = [
	["American", ["American.png", "American2.png"], 1125],
	["Asian", ["Asian1.png", "Asian2.png"], 1125],
	["BBQ", ["BBQ1.png", "BBQ2.png"], 1125],
	["Breakfast", ["Breakfast.png", "Breakfast2.png",
	               "Breakfast3.png", "Breakfast4.png"], 1000],
	["Caribbean", ["Caribbean.png", "Caribbean2.png"], 1125],
	["Chinese", ["Chinese.png", "Chinese2.png"], 1125],
	["Coffee Shop", 
		["Coffee0.png", "Coffee1.png", "Coffee2.png",
		 "Coffee3.png", "Coffee4.png", "Coffee5.png",
		 "Coffee6.png", "Coffee7.png", "Coffee8.png",
		 "Coffee9.png"], 575],
	["Deli", ["Deli1.png", "Deli2.png", "Deli3.png",
	          "Deli4.png", "Deli5.png"], 1000],
	["Fast Food", ["FastFood.png", "FastFood2.png"], 1125],
	["French", ["French1.png", "French2.png"], 1125],
	["Indian", ["Indian.png", "Indian2.png"], 1125],
	["Italian", ["Italian.png", "Italian2.png"], 1125],
	["Mediterranean", ["Mediterranean.png", "Mediterranean2.png"], 1125],
	["Mexican", ["Mexican.png", "Mexican2.png"], 1125],
	["Middle Eastern", 
		[ "MiddleEastern6.png", "MiddleEastern.png", "MiddleEastern2.png",
		  "MiddleEastern3.png", "MiddleEastern4.png", "MiddleEastern5.png"], 800],
	["Misc", ["Misc.png", "Misc2.png"], 1125],
	["Pizza", ["Pizza.png", "Pizza2.png"], 1125],
	["Pub", ["Pub.png", "Pub2.png", "Pub3.png"], 1125],
	["Seafood", ["Seafood1.png", "Seafood2.png"], 1125],
	["Steakhouse", ["Steakhouse.png", "Steakhouse2.png"], 1125],
	["Street Vendor", ["StreetVendor1.png", "StreetVendor2.png",
	                   "StreetVendor3.png", "StreetVendor4.png"], 1000],
	["Sushi", ["Sushi.png", "Sushi2.png"], 1125],
	["Vegetarian", ["Vegetarian.png", "Vegetarian2.png"], 1125],
	[null, ["xtra_Cake.png"], 0],
	[null, ["xtra_CandyApple.png"], 0],
	[null, ["xtra_Doughnut.png"], 0],
	[null, ["xtra_Fish.png"], 0],
	[null, ["xtra_Martini.png"], 0],
	[null, ["xtra_Octopus.png"], 0],
	[null, ["xtra_Sundae.png"], 0]
];

var defaultDinerData = [
	{name:"Dibella's Subs", type:7},
	{name:"Golden Wok", type:1},
	{name:"Pei Wai", type:5},
];

function initDineomatic()
{
	infoButton = new AppleInfoButton(document.getElementById("infoButton"), 
		document.getElementById("front"), "white", "white", showPrefs);

	if (window.widget) {
		widget.onshow = onshow;
		widget.onhide = onhide;

		/* preload icons */
		preloadIcons();

		/* setup javascript obj commonly in-use all over */
		dinerName = document.getElementById("dinerName");
		dinerType = document.getElementById("dinerType");
		dinerList = document.getElementById("dinerList");
		dinerBar = document.getElementById("dinerBar");
		dinnerPlate = document.getElementById("dinnerPlate");
		icon = document.getElementById("icon");
		sndButton = document.getElementById("soundButton");
		
		/* load diners stored in preferences */
		loadTypes();
		loadDiners();
		loadSoundConfig();
				
		/* set default icon */
		setIcon();
		widgetHidden = false;
	}
}

var imgObjArray = null;

function preloadIcons()
{
	/* 
	 * PRELOAD IMAGES IN ATTEMPT TO DO EVERYTHING POSSIBLE 
	 * TO SMOOTH OUT JAVASCRIPT ANIMATIONS, BUT SINCE IMAGES
	 * ARE ON LOCAL DISK, THIS PROBABLY DOESN'T HELP MUCH
	 *
	 * @@ JUST PROVES HOW LITTLE A C PROGRAMMER KNOWS ABOUT JAVASCRIPT @@
	 */
	
	imgObjArray = new Array(dinerTypes.length);
	
	for (var i = 0; i < dinerTypes.length; i++) {
		imgObjArray[i] = new Array(dinerTypes[i][1].length);

		for (var j = 0; j < dinerTypes[i][1].length; j++) {
			imgObjArray[i][j] = new Image();
			imgObjArray[i][j].src = "Images/Icons/" + dinerTypes[i][1][j];
		}
	}
}

function addPlateListeners()
{
	dinnerPlate.addEventListener("mouseover", plateMouseOver, true);
	dinnerPlate.addEventListener("mouseout", plateMouseOut, true);	
	dinnerPlate.addEventListener("mousedown", buttonMouseDown, true);	
}

function removePlateListeners()
{
	dinnerPlate.removeEventListener("mouseover", plateMouseOver, true);
	dinnerPlate.removeEventListener("mouseout", plateMouseOut, true);	
	dinnerPlate.removeEventListener("mousedown", buttonMouseDown, true);	
	dinnerPlate.src = "Images/dinnerPlate.png";
}

function plateMouseOver(event)
{
	if (event && event.target && event.target.id == "dinnerPlate") {
		dinnerPlate.src = "Images/dinnerPlate_mouseover.png";
	}
}

function plateMouseOut(event)
{
	dinnerPlate.src = "Images/dinnerPlate.png";
}

function loadTypes()
{
	for (var i = 0; i < dinerTypes.length && dinerTypes[i][0] != null; i++) {
		dinerType.add(new Option(dinerTypes[i][0], i));
	}
}

function loadDiners()
{
	var dinerDataStr = widget.preferenceForKey("dinerData");
	
	if (!empty(dinerDataStr)) {
		dinerData = eval(dinerDataStr);	
	}
	else {
		dinerData = defaultDinerData;
	}

	for (var i = 0; i < dinerData.length; i++) {
		addDinerRow(dinerData[i].name, dinerData[i].type);
	}
}

function loadSoundConfig()
{
	/* load sound config */
	if (widget.preferenceForKey("soundEnabled") != undefined)
		soundEnabled = widget.preferenceForKey("soundEnabled");			

	sndButton.src = "Images/" + ((soundEnabled) ? "sound_on.png" : "sound_off.png");
}

function buttonMouseDown(event)
{
	buttonObj = event.target;	
	buttonObj.src = "Images/" + buttonObj.id + "_mousedown.png";

	document.addEventListener("mousemove", buttonMouseMove, true);
	document.addEventListener("mouseup", buttonMouseUp, true);
	buttonObj.addEventListener("mouseover", buttonMouseOver, true);
	buttonObj.addEventListener("mouseout", buttonMouseOut, true);	
	
	mouseDownInButton = true;
	
	event.stopPropagation();
	event.preventDefault();
}

function buttonMouseMove(event)
{
	event.stopPropagation();
	event.preventDefault();
}

function buttonMouseOver(event)
{
	if (buttonObj) {
		buttonObj.src = "Images/" + buttonObj.id + "_mouseover.png";
		mouseDownInButton = true;
		event.stopPropagation();
		event.preventDefault();
	}
}

function buttonMouseOut(event)
{
	if (buttonObj) {
		buttonObj.src = "Images/" + buttonObj.id + ".png";
		mouseDownInButton = false;
		event.stopPropagation();
		event.preventDefault();
	}
}

function buttonMouseUp(event)
{
	if (buttonObj) {
		document.removeEventListener("mousemove", buttonMouseMove, true);
		document.removeEventListener("mouseup", buttonMouseUp, true);	
		buttonObj.removeEventListener("mouseover", buttonMouseOver, true);
		buttonObj.removeEventListener("mouseout", buttonMouseOut, true);
	
		buttonObj.src = "Images/" + buttonObj.id + ".png";
		if (mouseDownInButton) {
			if (buttonObj.id == "dinnerPlate") {
				buttonObj.src = "Images/" + buttonObj.id + "_mouseover.png";
			}		
			buttonClicked(event);
		}
	
		event.stopPropagation();
		event.preventDefault();
		
		buttonObj = null;
	}
}

function buttonClicked(event)
{
	if (buttonObj.id == "addButton" && !empty(dinerName.value)) {
		addDiner();
	}
	else if (buttonObj.id == "removeButton") {
		removeSelectedDinerRow();
	}
	else if (buttonObj.id == "doneButton") {
		hidePrefs();
	}
	else if (buttonObj.id == "dinnerPlate") {
		pickDiner();
	}
	
	/* focus dinerName field */
	dinerName.focus();
}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	vending = false;
	stopSound();
	stopAnimations();
	
	prefsChanged = false;
	
	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}
	
	front.style.display = "none";
	back.style.display = "block";
	
	if (window.widget) {
		setTimeout("widget.performTransition();", 0);
	}
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}
	
	back.style.display = "none";
	front.style.display = "block";
	
	if (window.widget) {
		setTimeout("widget.performTransition();", 0);
		
		/* if any changes made, write them out now */
		if (prefsChanged) {
			widget.setPreferenceForKey(createDinerDataJSString(), "dinerData");
			widget.setPreferenceForKey(soundEnabled, "soundEnabled");
		}
	}

	prefsChanged = false;
	startAnimations();
}

function onshow()
{
	widgetHidden = false;
	startAnimations();
}

function onhide()
{
	widgetHidden = true;
	vending = false;
	stopAnimations();
}

function addDiner()
{
	var name = trim(dinerName.value);
	
	if (!empty(name) && !dinerExists(name, dinerType.value)) {
		/* append to data array and add to listview */
		dinerData[dinerData.length] = {name: name, type: dinerType.value};
		addDinerRow(name, dinerType.value);
		
		/* clear out dinerName field, mark as dirty */
		dinerName.value = "";
		prefsChanged = true;
	}
}

function addDinerRow(name, type)
{
	var innerList = document.getElementById("inner-list");
	
	var row = document.createElement("div");	
	row.setAttribute("class", "row");
	row.setAttribute("onclick", "clickonbackrow(event, this);");
	
	var namespan = document.createElement("span");
	namespan.setAttribute("class", "diner-name");
	namespan.innerText = name;
	row.appendChild(namespan);
	
	var typespan = document.createElement("span");
	typespan.setAttribute("class", "diner-type");
	typespan.innerText = dinerTypes[type][0];
	row.appendChild(typespan);
	
	innerList.appendChild(row);
	
	return row;
}

function removeSelectedDinerRow()
{
	if (selectedRow != null) {
		var index = findIndexOfChild(selectedRow);
		var parentNode = selectedRow.parentNode;
		
		/* remove row from data array and listview */
		dinerData.splice(index, 1);
		parentNode.removeChild(selectedRow);

		/* reset picked eatery */
		pickedDiner = -1;
		
		/* row removed, no more selection */
		selectedRow = null;
		
		/* make sure prefs get updated when prefs are hidden with done button */
		prefsChanged = true;
	}
}

function pickDiner()
{
	vending = true;

	removePlateListeners();
	stopIconTimer();
	setDinerBarText("", false, 0);

	/* shuffle diner icon */
	dinerBar.style.opacity = 0;
	shuffleCount = -1;
	shuffleFinalDelay = -1;
	randNum = -1;
	neonPlayCount = 0;

	stopSound();
	if (soundEnabled) {
		playSound("Activate");
	}
	else {
		setTimeout("ActivateSoundFinished()", 400);
	}
}

function ActivateSoundFinished()
{
	if (vending) {
		setTimeout("vend()", 25);
	}
}

function VendSoundFinished()
{
	if (vending) {
		++shuffleCount;
		
		if (shuffleCount < shuffleFullSpdClicks) {
			vend();
		}
		else if (shuffleCount < shuffleMax) {
			setTimeout("vend()",
				shuffleExpDelay + 
					Math.pow(shuffleCount - shuffleFullSpdClicks, shuffleExp));
		}
		else {
			shuffleFinalDelay = 1.35 * 
				(shuffleExpDelay + 
					Math.pow(shuffleCount - shuffleFullSpdClicks, shuffleExp));
			setTimeout("setFinalDinerIcon()", shuffleFinalDelay);
		}
	}
}

function SelectSoundFinished()
{
	if (soundEnabled && !vending && !widgetHidden && neonPlayCount == 0) {
		setTimeout("playSound('Neon')", 850);
	}
}

function NeonSoundFinished()
{
	neonPlayCount++;
	if (soundEnabled && !vending && !widgetHidden && neonPlayCount == 1) {
		setTimeout("playSound('Neon')", 600);
	}
}

function vend()
{
	if (vending) {
		/* pick random icon to display as vending sound plays */
		randNum = randIcon(randNum, dinerTypes.length);
		icon.src = "Images/Icons/" + 
			dinerTypes[randNum][1][0];
	
		/* repeat vending sound */
		if (soundEnabled) {
			playSound("Vend");
		}
		else {
			setTimeout("VendSoundFinished()", 205);
		}
	}
}

function setFinalDinerIcon()
{
	if (vending) {
		/* pseudo-random pick from dinerData[] */
		if (dinerData.length == 1) {
			/* No need to pick random is only one diner to choose from */
			pickedDiner = 0;
		}
		else {
			if (pickedDiner == -1 || pickedDiner >= dinerData.length) {
				pickedDiner = randNum;
			}
			do {
				pickedDiner = randDiner(pickedDiner, dinerData.length);
			} while (pickedDiner == randNum);
		}
		
		stopSound();
		playSound("Select");
		vending = false;

		/* fade in diner bar text */
		setDinerBarText(dinerData[pickedDiner].name, true, 1.5 * shuffleFinalDelay);
			
		/* setup icon, animate if multiple pngs exist */
		setTimeout("setIcon()", 50);
	}
}

function fadeDinerBar(animation, current, start, finish)
{
	dinerBar.style.opacity = current;
}

function animateDinerIcon()
{
	var icons = dinerTypes[dinerData[pickedDiner].type][1];
	var i = animateIndex;
		
	/* reset index if went pass last array element */
	if (++animateIndex == icons.length) {
		animateIndex = 0;
	}

	/* set icon to next in diner types array */	
	icon.src = "Images/Icons/" + icons[i];
}

function playSound(sound)
{
	if (soundEnabled == true && DOMPluginController) {
		DOMPluginController.playSound(sound);
	}
}

function stopSound()
{
	if (soundEnabled == true && DOMPluginController) {
		DOMPluginController.stopSounds();
	}
}

function seed()
{
	if (DOMPluginController) {
		DOMPluginController.seed();
	}
}

function randIcon(prev, max)
{
	if (DOMPluginController) {
		return DOMPluginController.randIcon(prev, max);
	}

	return 0;
}

function randDiner(prev, max)
{
	if (DOMPluginController) {
		return DOMPluginController.randDiner(prev, max);
	}

	return 0;
}

function findIndexOfChild(child)
{
	var node = child.parentNode;
	var i = 0;
	
	for (node = node.firstChild; node != null; node = node.nextSibling, ++i) {
		if (node == child)
			return i;
	}
	
	return -1;
}

function clickonbackrow(event, row)
{
	if (selectedRow != row) {
		if (selectedRow != null)
			selectedRow.setAttribute("class", "row");
		
		selectedRow = row;	
		row.setAttribute ("class", "row select");
	}	
	
	if (event) {
		event.stopPropagation();
		event.preventDefault();
	}
}

function toggleSound(event)
{	
	if (soundEnabled) {
		sndButton.src = "Images/sound_off.png";
	}
	else {
		sndButton.src = "Images/sound_on.png";
	}
	
	soundEnabled = !soundEnabled;
	prefsChanged = true;
}

function dinerExists(name, type)
{	
	for (var i = 0; i < dinerData.length; ++i) {
		if (dinerData[i].name == name && dinerData[i].type == type)
			return true;
	}

	return false;
}

function createDinerDataJSString()
{
	var str = "[";
	
	for (var i = 0; i < dinerData.length; ++i) {
		var data = dinerData[i];
		if (i != 0)
			str += ",";
		// make sure the name does not have any single quotes in it
		str += "{name:'" 
			+ data.name.replace(/\'/g, "\\'") 
			+ "',type:" 
			+ data.type + "}";
	}
	
	str += "]";
	
	return str;
}

function sortDinerData()
{	
	dinerData = dinerData.sort(
		function(a,b) {
			if ((a.name.toLowerCase()+"") < (b.name.toLowerCase()+"")) {
				return -1;
			}
			
			if ((a.name.toLowerCase()+"") > (b.name.toLowerCase()+"")) {
				return 1;
			}
			
			return 0;
		}
	);
}

function trim(str)
{
	str = str.replace(/^\s+/g, "");
	return str.replace(/\s+$/g, "");
}

function empty(str)
{
	if (str == null || str.length == 0 || trim(str+"").length == 0) {
		return true;
	}
	
	return false;
}

function openURL(url) {
	if (window.widget) {
		widget.openURL(url);
	}
}

function setIcon()
{
	/* 
	 * disable plate and animation until we determine
	 * if we have enough data/state to enable them
	 */
	removePlateListeners();
	stopIconTimer();
	
	/* in case for some reason pickedDiner is set out-of-range */
	if (pickedDiner >= dinerData.length) {
		pickedDiner = -1;
	}
	
	if (pickedDiner == -1) {
		icon.src = "Images/Icons/Iconfactory.png";

		/* reset status bar text */
		dinerBar.style.opacity = 1;
		if (dinerData.length > 0) {
			setDinerBarText(defaultDinerBarText, false, 0);
		} else {
			setDinerBarText(emptyDinerBarText, false, 0);
		}
	}
	else {
		/* display icon */
		icon.src = "Images/Icons/" + dinerTypes[dinerData[pickedDiner].type][1][0];
		if (dinerTypes[dinerData[pickedDiner].type][1].length > 1) {
			startIconTimer();
		}
	}
	
	/* if eateries available, enable diner plate */
	if (dinerData.length > 0) {
		addPlateListeners();
	}
}

function startIconTimer()
{
	animateIndex = 1;
	animateTimer = setInterval("animateDinerIcon()",
		dinerTypes[dinerData[pickedDiner].type][2]);
}


function stopIconTimer()
{
	if (animateTimer != null) {
		clearInterval(animateTimer);
		animateTimer = null;
	}
}

function setDinerBarText(text, fade, delay)
{
	dinerBar.innerText = text;
	
	/* if we overflowed, scroll diner name instead, 167 number hard coded
	 * because Safari lacks element.getComputedStyle() javascript */
	if (dinerBar.scrollWidth > 167) {
		dinerBar.innerHTML = 
			"<marquee id='dbmarquee' behavior='scroll' scrolldelay='175' width='167'>" +
			dinerBar.innerText + "</marquee>";
	}

	if (fade) {
		var fader = new AppleAnimator(delay, 50, 0.0, 1.0, fadeDinerBar);
		fader.start();
	}
	else {
		dinerBar.style.opacity = 1;
	}
}

function startDinerBarMarquee()
{
	var mq = document.getElementById("dbmarquee");
	if (mq) {
		mq.start();
	}
}

function stopDinerBarMarquee()
{
	var mq = document.getElementById("dbmarquee");
	if (mq) {
		mq.stop();
	}
}

function startAnimations()
{
	setIcon();
	if (dinerBar.innerText == "" && dinerData[pickedDiner]) {
		setDinerBarText(dinerData[pickedDiner].name, false, 0);
	}
	startDinerBarMarquee();
}

function stopAnimations()
{
	stopDinerBarMarquee();
	stopIconTimer();
}
